import 'dart:developer';

import 'package:flutter/cupertino.dart';
import 'package:dio/dio.dart';
import 'baseurl.dart';

class BaseDataSource {
  Dio dio;
  var baseUrl;
  BaseDataSource({this.baseUrl =baseurl,this.dio}){
    dio =
        Dio(
          BaseOptions(
            baseUrl: baseUrl,
            receiveDataWhenStatusError: true,
            headers: {"Content-Type": "application/json"},
            validateStatus: (_)=>true,
          ),

        );
  }
  Future<Response> getData({ String url, Map<String,dynamic> query, String token}) async {
    printRequest(url, query,token);
    Response response = await dio?.get(url,queryParameters: query,options:  Options(
        headers: {"Authorization": "bearer $token",'Content-Type': 'application/json'
        }
    ));
    printResponse(url, response,token);
    return  response ;

  }

  Future<Response> postData({ String url, Map<String,dynamic> query, String token}) async {
    printRequest(url, query,token);
    Response response = await dio?.post(url,data: query,options:  Options(
        headers: {"Authorization": "bearer $token",'Content-Type': 'application/json'
        }
    ));
    printResponse(url, response,token);
    return response ;
  }
  printRequest(String url, Map<String, dynamic> query,String token){
    log("request -> URL -> $url");
    log("request -> query -> $query");
    log("request -> token -> $token");
  }
  printResponse(String url, Response response,String token){
    log("response -> url -> $url");
    log("response -> response -> ${response}");
    log("response -> token -> $token");
  }
}