import 'dart:developer';
import 'package:signalr_client/hub_connection.dart';
import 'package:signalr_client/hub_connection_builder.dart';

class SignalRHelper{
  static final SignalRHelper _singleton = SignalRHelper._internal();

  factory SignalRHelper() {
    return _singleton;
  }
  SignalRHelper._internal();

  var url = 'https://microservices.itgsolutions.com/ITG.RealTime.APIs/RealTimeSignalRServer';

  setUrl(var url){
    this.url=url;
    return _singleton;
  }
  HubConnection _hubConnection;
  var messageList = <dynamic>[];
  String textMessage='';
  connect() {
    log("connect");
    _hubConnection = HubConnectionBuilder().withUrl(url).build();
    start();
    return _hubConnection;
  }
  start(){
    _hubConnection.start();
    return _hubConnection;
  }
  void onClose() {
    _hubConnection.onclose((error) {
      log('Connection Close');
    });
  }
  call(String p1) {
    final result= _hubConnection.invoke('SendMessage', args:<Object>["ParameterValue"]);
    log("Result: '$result");
    return _hubConnection;
  }
  listen(String event, Function action){
    _hubConnection.on(event, action);
    return _hubConnection;
  }
}