import 'dart:convert';

import 'CommenModel.dart';


class CreateGroupChatResponse extends BaseModel{
  int conversationGroupId;
  String defaultDesc;
  String lastMessage;
  int usersCanLeaveGroup;
  int readOnly;
  int projectId;
  int microserviceId;
  String keyRefId;
  int conversationGroupTypeId;
  List<ConversationGroupMemberDto> conversationGroupMemberDtos;
  int createdby;
  String creationdate;
  dynamic modifiedby;
  dynamic modificationdate;

  CreateGroupChatResponse({
    this.conversationGroupId,
    this.defaultDesc,
    this.lastMessage,
    this.usersCanLeaveGroup,
    this.readOnly,
    this.projectId,
    this.microserviceId,
    this.keyRefId,
    this.conversationGroupTypeId,
    this.conversationGroupMemberDtos,
    this.createdby,
    this.creationdate,
    this.modifiedby,
    this.modificationdate,
  });



  factory CreateGroupChatResponse.fromJson(Map<String, dynamic> json) => CreateGroupChatResponse(
    conversationGroupId: json["ConversationGroupID"],
    defaultDesc: json["DefaultDesc"],
    lastMessage: json["LastMessage"],
    usersCanLeaveGroup: json["UsersCanLeaveGroup"],
    readOnly: json["ReadOnly"],
    projectId: json["ProjectID"],
    microserviceId: json["MicroserviceID"],
    keyRefId: json["KeyRefID"],
    conversationGroupTypeId: json["ConversationGroupTypeID"],
    conversationGroupMemberDtos: List<ConversationGroupMemberDto>.from(json["ConversationGroupMemberDtos"].map((x) => ConversationGroupMemberDto.fromJson(x))),
    createdby: json["CREATEDBY"],
    creationdate:json["CREATIONDATE"],
    modifiedby: json["MODIFIEDBY"],
    modificationdate: json["MODIFICATIONDATE"],
  );

  Map<String, dynamic> toJson() => {
    "ConversationGroupID": conversationGroupId,
    "DefaultDesc": defaultDesc,
    "LastMessage": lastMessage,
    "UsersCanLeaveGroup": usersCanLeaveGroup,
    "ReadOnly": readOnly,
    "ProjectID": projectId,
    "MicroserviceID": microserviceId,
    "KeyRefID": keyRefId,
    "ConversationGroupTypeID": conversationGroupTypeId,
    "ConversationGroupMemberDtos": List<dynamic>.from(conversationGroupMemberDtos.map((x) => x.toJson())),
    "CREATEDBY": createdby,
    "CREATIONDATE": creationdate,
    "MODIFIEDBY": modifiedby,
    "MODIFICATIONDATE": modificationdate,
  };
}

class ConversationGroupMemberDto {
  int conversationGroupId;
  int userProfileId;
  String exitGroupDate;
  String lastSeen;
  String lastCheck;
  int createdby;
  String creationdate;
  dynamic modifiedby;
  dynamic modificationdate;
  ConversationGroupMemberDto({
    this.conversationGroupId,
    this.userProfileId,
    this.exitGroupDate,
    this.lastSeen,
    this.lastCheck,
    this.createdby,
    this.creationdate,
    this.modifiedby,
    this.modificationdate,
  });

  factory ConversationGroupMemberDto.fromJson(Map<String, dynamic> json) => ConversationGroupMemberDto(
    conversationGroupId: json["ConversationGroupID"],
    userProfileId: json["UserProfileID"],
    exitGroupDate: json["ExitGroupDate"],
    lastSeen: json["LastSeen"],
    lastCheck: json["LastCheck"],
    createdby: json["CREATEDBY"],
    creationdate: json["CREATIONDATE"],
    modifiedby: json["MODIFIEDBY"],
    modificationdate: json["MODIFICATIONDATE"],
  );

  Map<String, dynamic> toJson() => {
    "ConversationGroupID": conversationGroupId,
    "UserProfileID": userProfileId,
    "ExitGroupDate": exitGroupDate,
    "LastSeen": lastSeen,
    "LastCheck": lastCheck,
    "CREATEDBY": createdby,
    "CREATIONDATE": creationdate,
    "MODIFIEDBY": modifiedby,
    "MODIFICATIONDATE": modificationdate,
  };
}
