import 'dart:convert';

import 'package:equatable/equatable.dart';

GetChatMembersByConversationGroupIdResponse getChatMembersByConversationGroupIdModelFromJson(String str) => GetChatMembersByConversationGroupIdResponse.fromJson(json.decode(str));

String getChatMembersByConversationGroupIdModelToJson(GetChatMembersByConversationGroupIdResponse data) => json.encode(data.toJson());

class GetChatMembersByConversationGroupIdResponse extends Equatable {

  String message;
  bool isSuccee;
  int returnId;
  List<GetChatMembersByConversationGroupIdModelData> data;
  String typesOfData;
  List<dynamic> results;

  GetChatMembersByConversationGroupIdResponse({
    this.message,
    this.isSuccee,
    this.returnId,
    this.data,
    this.typesOfData,
    this.results,
  });

  factory GetChatMembersByConversationGroupIdResponse.fromJson(Map<String, dynamic> json) => GetChatMembersByConversationGroupIdResponse(
    message: json["Message"],
    isSuccee: json["IsSuccee"],
    returnId: json["ReturnId"],
    data: List<GetChatMembersByConversationGroupIdModelData>.from(json["Data"].map((x) => GetChatMembersByConversationGroupIdModelData.fromJson(x))),
    typesOfData: json["TypesOfData"],
    results: List<dynamic>.from(json["Results"].map((x) => x)),
  );

  Map<String, dynamic> toJson() => {
    "Message": message,
    "IsSuccee": isSuccee,
    "ReturnId": returnId,
    "Data": List<dynamic>.from(data.map((x) => x.toJson())),
    "TypesOfData": typesOfData,
    "Results": List<dynamic>.from(results.map((x) => x)),
  };

  @override
  // TODO: implement props
  List<Object> get props => [message,returnId,typesOfData,results,isSuccee];
}

class GetChatMembersByConversationGroupIdModelData extends Equatable{
  int conversationGroupId;
  int messageId;
  int userProfileId;
  int seenFlag;
  String calculatedTime;
  int createdby;
  String creationdate;
  String modifiedby;
  String modificationdate;
  GetChatMembersByConversationGroupIdModelData({
    this.conversationGroupId,
    this.messageId,
    this.userProfileId,
    this.seenFlag,
    this.calculatedTime,
    this.createdby,
    this.creationdate,
    this.modifiedby,
    this.modificationdate,
  });
  factory GetChatMembersByConversationGroupIdModelData.fromJson(Map<String, dynamic> json) => GetChatMembersByConversationGroupIdModelData(
    conversationGroupId: json["ConversationGroupID"],
    messageId: json["MessageID"],
    userProfileId: json["UserProfileID"],
    seenFlag: json["SeenFlag"],
    calculatedTime: json["CalculatedTime"],
    createdby: json["CREATEDBY"],
    creationdate: json["CREATIONDATE"],
    modifiedby: json["MODIFIEDBY"],
    modificationdate: json["MODIFICATIONDATE"],
  );

  Map<String, dynamic> toJson() => {
    "ConversationGroupID": conversationGroupId,
    "MessageID": messageId,
    "UserProfileID": userProfileId,
    "SeenFlag": seenFlag,
    "CalculatedTime": calculatedTime,
    "CREATEDBY": createdby,
    "CREATIONDATE": creationdate,
    "MODIFIEDBY": modifiedby,
    "MODIFICATIONDATE": modificationdate,
  };

  @override
  // TODO: implement props
  List<Object> get props => [conversationGroupId,messageId,userProfileId,seenFlag,calculatedTime,createdby,creationdate,modifiedby,modificationdate];
}
