/// Message : null
/// IsSuccee : true
/// ReturnId : 156
/// Data : {"MessageID":366,"MessageText":"test","SenderUserProfileID":43547,"ConversationGroupID":156,"ProjectID":0,"MicroserviceID":0,"CreationDate":"2021-12-13T14:23:35.3194318+02:00","ChatMemberDtos":[{"ConversationGroupID":156,"MessageID":366,"UserProfileID":43547,"SeenFlag":1,"CalculatedTime":null,"CreationDate":"2021-12-13T14:23:35.3412828+02:00"},{"ConversationGroupID":156,"MessageID":366,"UserProfileID":43156,"SeenFlag":0,"CalculatedTime":null,"CreationDate":"2021-12-13T14:23:35.3414118+02:00"}],"AttachmentDtos":[""],"CalculatedTime":"02:23 PM"}
/// TypesOfData : null
/// Results : [""]

class ShowDetailsChatModel {
  dynamic _message;
  bool _isSuccee;
  int _returnId;
  Data _data;
  dynamic _typesOfData;
  List<String> _results;

  dynamic get message => _message;
  bool get isSuccee => _isSuccee;
  int get returnId => _returnId;
  Data get data => _data;
  dynamic get typesOfData => _typesOfData;
  List<String> get results => _results;

  ShowDetailsChatModel({
      dynamic message, 
      bool isSuccee, 
      int returnId, 
      Data data, 
      dynamic typesOfData, 
      List<String> results}){
    _message = message;
    _isSuccee = isSuccee;
    _returnId = returnId;
    _data = data;
    _typesOfData = typesOfData;
    _results = results;
}

  ShowDetailsChatModel.fromJson(dynamic json) {
    _message = json['Message'];
    _isSuccee = json['IsSuccee'];
    _returnId = json['ReturnId'];
    _data = json['Data'] != null ? Data.fromJson(json['Data']) : null;
    _typesOfData = json['TypesOfData'];
    _results = json['Results'] != null ? json['Results'].cast<String>() : [];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['Message'] = _message;
    map['IsSuccee'] = _isSuccee;
    map['ReturnId'] = _returnId;
    if (_data != null) {
      map['Data'] = _data.toJson();
    }
    map['TypesOfData'] = _typesOfData;
    map['Results'] = _results;
    return map;
  }

}

/// MessageID : 366
/// MessageText : "test"
/// SenderUserProfileID : 43547
/// ConversationGroupID : 156
/// ProjectID : 0
/// MicroserviceID : 0
/// CreationDate : "2021-12-13T14:23:35.3194318+02:00"
/// ChatMemberDtos : [{"ConversationGroupID":156,"MessageID":366,"UserProfileID":43547,"SeenFlag":1,"CalculatedTime":null,"CreationDate":"2021-12-13T14:23:35.3412828+02:00"},{"ConversationGroupID":156,"MessageID":366,"UserProfileID":43156,"SeenFlag":0,"CalculatedTime":null,"CreationDate":"2021-12-13T14:23:35.3414118+02:00"}]
/// AttachmentDtos : [""]
/// CalculatedTime : "02:23 PM"

class Data {
  int _messageID;
  String _messageText;
  int _senderUserProfileID;
  int _conversationGroupID;
  int _projectID;
  int _microserviceID;
  String _creationDate;
  List<ChatMemberDtos> _chatMemberDtos;
  List<String> _attachmentDtos;
  String _calculatedTime;

  int get messageID => _messageID;
  String get messageText => _messageText;
  int get senderUserProfileID => _senderUserProfileID;
  int get conversationGroupID => _conversationGroupID;
  int get projectID => _projectID;
  int get microserviceID => _microserviceID;
  String get creationDate => _creationDate;
  List<ChatMemberDtos> get chatMemberDtos => _chatMemberDtos;
  List<String> get attachmentDtos => _attachmentDtos;
  String get calculatedTime => _calculatedTime;

  Data({
      int messageID, 
      String messageText, 
      int senderUserProfileID, 
      int conversationGroupID, 
      int projectID, 
      int microserviceID, 
      String creationDate, 
      List<ChatMemberDtos> chatMemberDtos, 
      List<String> attachmentDtos, 
      String calculatedTime}){
    _messageID = messageID;
    _messageText = messageText;
    _senderUserProfileID = senderUserProfileID;
    _conversationGroupID = conversationGroupID;
    _projectID = projectID;
    _microserviceID = microserviceID;
    _creationDate = creationDate;
    _chatMemberDtos = chatMemberDtos;
    _attachmentDtos = attachmentDtos;
    _calculatedTime = calculatedTime;
}

  Data.fromJson(dynamic json) {
    _messageID = json['MessageID'];
    _messageText = json['MessageText'];
    _senderUserProfileID = json['SenderUserProfileID'];
    _conversationGroupID = json['ConversationGroupID'];
    _projectID = json['ProjectID'];
    _microserviceID = json['MicroserviceID'];
    _creationDate = json['CreationDate'];
    if (json['ChatMemberDtos'] != null) {
      _chatMemberDtos = [];
      json['ChatMemberDtos'].forEach((v) {
        _chatMemberDtos.add(ChatMemberDtos.fromJson(v));
      });
    }
    _attachmentDtos = json['AttachmentDtos'] != null ? json['AttachmentDtos'].cast<String>() : [];
    _calculatedTime = json['CalculatedTime'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['MessageID'] = _messageID;
    map['MessageText'] = _messageText;
    map['SenderUserProfileID'] = _senderUserProfileID;
    map['ConversationGroupID'] = _conversationGroupID;
    map['ProjectID'] = _projectID;
    map['MicroserviceID'] = _microserviceID;
    map['CreationDate'] = _creationDate;
    if (_chatMemberDtos != null) {
      map['ChatMemberDtos'] = _chatMemberDtos.map((v) => v.toJson()).toList();
    }
    map['AttachmentDtos'] = _attachmentDtos;
    map['CalculatedTime'] = _calculatedTime;
    return map;
  }

}

/// ConversationGroupID : 156
/// MessageID : 366
/// UserProfileID : 43547
/// SeenFlag : 1
/// CalculatedTime : null
/// CreationDate : "2021-12-13T14:23:35.3412828+02:00"

class ChatMemberDtos {
  int _conversationGroupID;
  int _messageID;
  int _userProfileID;
  int _seenFlag;
  dynamic _calculatedTime;
  String _creationDate;

  int get conversationGroupID => _conversationGroupID;
  int get messageID => _messageID;
  int get userProfileID => _userProfileID;
  int get seenFlag => _seenFlag;
  dynamic get calculatedTime => _calculatedTime;
  String get creationDate => _creationDate;

  ChatMemberDtos({
      int conversationGroupID, 
      int messageID, 
      int userProfileID, 
      int seenFlag, 
      dynamic calculatedTime, 
      String creationDate}){
    _conversationGroupID = conversationGroupID;
    _messageID = messageID;
    _userProfileID = userProfileID;
    _seenFlag = seenFlag;
    _calculatedTime = calculatedTime;
    _creationDate = creationDate;
}

  ChatMemberDtos.fromJson(dynamic json) {
    _conversationGroupID = json['ConversationGroupID'];
    _messageID = json['MessageID'];
    _userProfileID = json['UserProfileID'];
    _seenFlag = json['SeenFlag'];
    _calculatedTime = json['CalculatedTime'];
    _creationDate = json['CreationDate'];
  }

  Map<String, dynamic> toJson() {
    var map = <String, dynamic>{};
    map['ConversationGroupID'] = _conversationGroupID;
    map['MessageID'] = _messageID;
    map['UserProfileID'] = _userProfileID;
    map['SeenFlag'] = _seenFlag;
    map['CalculatedTime'] = _calculatedTime;
    map['CreationDate'] = _creationDate;
    return map;
  }

}