import 'dart:convert';

ShowdetailsModel showdetailsModelFromJson(String str) => ShowdetailsModel.fromJson(json.decode(str));

String showdetailsModelToJson(ShowdetailsModel data) => json.encode(data.toJson());

class ShowdetailsModel {
  ShowdetailsModel({
    this.message,
    this.isSuccee,
    this.returnId,
    this.data,
    this.typesOfData,
    this.results,
  });

  dynamic message;
  bool isSuccee;
  int returnId;
  List<Datum> data;
  dynamic typesOfData;
  List<dynamic> results;

  factory ShowdetailsModel.fromJson(Map<String, dynamic> json) => ShowdetailsModel(
    message: json["Message"],
    isSuccee: json["IsSuccee"],
    returnId: json["ReturnId"],
    data: List<Datum>.from(json["Data"].map((x) => Datum.fromJson(x))),
    typesOfData: json["TypesOfData"],
    results: List<dynamic>.from(json["Results"].map((x) => x)),
  );

  Map<String, dynamic> toJson() => {
    "Message": message,
    "IsSuccee": isSuccee,
    "ReturnId": returnId,
    "Data": List<dynamic>.from(data.map((x) => x.toJson())),
    "TypesOfData": typesOfData,
    "Results": List<dynamic>.from(results.map((x) => x)),
  };
}

class Datum {
  Datum({
    this.messageId,
    this.messageText,
    this.senderUserProfileId,
    this.conversationGroupId,
    this.projectId,
    this.microserviceId,
    this.creationDate,
    this.chatMemberDtos,
    this.attachmentDtos,
    this.calculatedTime,
  });

  int messageId;
  String messageText;
  int senderUserProfileId;
  int conversationGroupId;
  int projectId;
  int microserviceId;
  DateTime creationDate;
  List<ChatMemberDto> chatMemberDtos;
  List<dynamic> attachmentDtos;
  String calculatedTime;

  factory Datum.fromJson(Map<String, dynamic> json) => Datum(
    messageId: json["MessageID"],
    messageText: json["MessageText"],
    senderUserProfileId: json["SenderUserProfileID"],
    conversationGroupId: json["ConversationGroupID"],
    projectId: json["ProjectID"],
    microserviceId: json["MicroserviceID"],
    creationDate: DateTime.parse(json["CreationDate"]),
    chatMemberDtos: List<ChatMemberDto>.from(json["ChatMemberDtos"].map((x) => ChatMemberDto.fromJson(x))),
    attachmentDtos: List<dynamic>.from(json["AttachmentDtos"].map((x) => x)),
    calculatedTime: json["CalculatedTime"],
  );

  Map<String, dynamic> toJson() => {
    "MessageID": messageId,
    "MessageText": messageText,
    "SenderUserProfileID": senderUserProfileId,
    "ConversationGroupID": conversationGroupId,
    "ProjectID": projectId,
    "MicroserviceID": microserviceId,
    "CreationDate": creationDate.toIso8601String(),
    "ChatMemberDtos": List<dynamic>.from(chatMemberDtos.map((x) => x.toJson())),
    "AttachmentDtos": List<dynamic>.from(attachmentDtos.map((x) => x)),
    "CalculatedTime": calculatedTime,
  };
}

class ChatMemberDto {
  ChatMemberDto({
    this.conversationGroupId,
    this.messageId,
    this.userProfileId,
    this.seenFlag,
    this.calculatedTime,
    this.creationDate,
  });

  int conversationGroupId;
  int messageId;
  int userProfileId;
  int seenFlag;
  dynamic calculatedTime;
  DateTime creationDate;

  factory ChatMemberDto.fromJson(Map<String, dynamic> json) => ChatMemberDto(
    conversationGroupId: json["ConversationGroupID"],
    messageId: json["MessageID"],
    userProfileId: json["UserProfileID"],
    seenFlag: json["SeenFlag"],
    calculatedTime: json["CalculatedTime"],
    creationDate: DateTime.parse(json["CreationDate"]),
  );

  Map<String, dynamic> toJson() => {
    "ConversationGroupID": conversationGroupId,
    "MessageID": messageId,
    "UserProfileID": userProfileId,
    "SeenFlag": seenFlag,
    "CalculatedTime": calculatedTime,
    "CreationDate": creationDate.toIso8601String(),
  };
}
