import 'dart:convert';

/// Message : null
/// IsSuccee : false
/// ReturnId : 0
/// Data : null
/// TypesOfData : null
/// Results : [{"enITGResult":2,"Key":"501","Value":"ExceptionType :: System.NullReferenceException | Message :: Object reference not set to an instance of an object.","Message":null}]

UserTokenModel userTokenModelFromJson(String str) => UserTokenModel.fromJson(json.decode(str));

String userTokenModelToJson(UserTokenModel data) => json.encode(data.toJson());

class UserTokenModel {
  UserTokenModel({
    this.accessToken,
    this.tokenType,
    this.refreshToken,
    this.expiresIn,
    this.issued,
    this.expires,
  });

  String accessToken;
  String tokenType;
  String refreshToken;
  int expiresIn;
  DateTime issued;
  DateTime expires;

  factory UserTokenModel.fromJson(Map<String, dynamic> json) => UserTokenModel(
    accessToken: json["access_token"],
    tokenType: json["token_type"],
    refreshToken: json["refresh_token"],
    expiresIn: json["expires_in"],
    issued: DateTime.parse(json["issued"]),
    expires: DateTime.parse(json["expires"]),
  );

  Map<String, dynamic> toJson() => {
    "access_token": accessToken,
    "token_type": tokenType,
    "refresh_token": refreshToken,
    "expires_in": expiresIn,
    "issued": issued.toIso8601String(),
    "expires": expires.toIso8601String(),
  };
}
