import 'dart:convert';

import 'package:itg_chat/core/base/base_datasource.dart';
import 'package:itg_chat/core/base/baseurl.dart';
import 'package:itg_chat/features/data/model/CommenModel.dart';
import 'package:itg_chat/features/data/model/create_group_chat_model.dart';
import 'package:itg_chat/features/data/model/generate_token_model.dart';
import 'package:itg_chat/features/data/model/get_all_message_model.dart';
import 'package:itg_chat/features/data/model/get_chat_member_byvonversation_groupIDModel.dart';
import 'package:itg_chat/features/data/model/get_history_messages_between_two_users.dart';
import 'package:itg_chat/features/data/model/get_list_of_latest_seen_messages.dart';
import 'package:itg_chat/features/data/model/show_details_chat_model.dart';
import 'package:itg_chat/features/data/model/showdetails_model.dart';
import 'package:itg_chat/features/data/model/user_token_model.dart';
import 'package:itg_chat/features/domain/repo/repo.dart';
import 'package:rxdart/rxdart.dart';

class CahtRepoImplemtion extends BaseDataSource implements ChatRemoterepo {

  BaseDataSource d;
  CahtRepoImplemtion(this.d) : super(dio: d.dio);
  @override
  Future<BehaviorSubject<GetChatMembersByConversationGroupIdResponse>> getMessages(int groupid,int ConversationGroupID,int ProjectID,int MicroserviceID,int SenderUserProfileID,int UserProfileID) async{
     BehaviorSubject<GetChatMembersByConversationGroupIdResponse> dateVaule = BehaviorSubject<GetChatMembersByConversationGroupIdResponse>();
     await d.getData(url: get_Message(groupid), query:{'ConversationGroupID':ConversationGroupID,'ProjectID':ProjectID,'MicroserviceID':MicroserviceID,'SenderUserProfileID':SenderUserProfileID,'UserProfileID':UserProfileID}).then((value) {
       dateVaule.sink.add(GetChatMembersByConversationGroupIdResponse.fromJson(value.data));
     }).catchError((error){
       print(error.toString());
     });
     return dateVaule;
  }
  @override
  Future<BehaviorSubject<HistoryMessagesResponse>> getHistoryMessagesBetweenTwoUsers(id,indetifier) async{
    BehaviorSubject<HistoryMessagesResponse> dateVaulegetHistory = BehaviorSubject<HistoryMessagesResponse>();
    await d.getData(url: gethistoryMessagesBetweenTwoUsers(id,indetifier)).then((value) {
      dateVaulegetHistory.sink.add(HistoryMessagesResponse.fromJson(value.data));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaulegetHistory;
  }
  @override
  Future<BehaviorSubject<Message>> getlistofseenmessages(int id) async{
    BehaviorSubject<Message> dateVaulegetlistofseen = BehaviorSubject<Message>();
    // TODO: implement getlistofunseenmessages
    await d.getData(url: seenMessage(id)).then((value) {
      // dateVaulegetlistofseen.sink.add(value.data);
      dateVaulegetlistofseen.sink.add(Message.fromJson(value.data));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaulegetlistofseen;
  }
  @override
  Future<BehaviorSubject<Message>> getlistofunseenmessages(int id) async{
    BehaviorSubject<Message> dateVaulegetlistofunseenmessages = BehaviorSubject<Message>();
    // TODO: implement getlistofunseenmessages
    await d.getData(url: unseenMessage(id)).then((value) {
       dateVaulegetlistofunseenmessages.sink.add(Message.fromJson(value.data));
    }).catchError((error){
      print(error.toString(),);
    });
    return dateVaulegetlistofunseenmessages;
  }
  @override
  Future<BehaviorSubject<Message>> sendMessageToGroupBetweenTwoUsers(int ConversationGroupID,int SenderUserProfileID, String MessageText) async{
    BehaviorSubject<Message> dateVaulegetsendMessageToGroup = BehaviorSubject<Message>();
    // TODO: implement sendMessageToGroupBetweenTwoUsers
    await postData(url: sendmessageGroup,query:{'ConversationGroupID':ConversationGroupID,'SenderUserProfileID':SenderUserProfileID,'MessageText':MessageText} ).then((value) {
      dateVaulegetsendMessageToGroup.sink.add(Message.fromJson(value.data));
     }).catchError((error){
      print(error.toString());
    });
    return dateVaulegetsendMessageToGroup;
  }
  @override
  Future<BehaviorSubject<BaseModel>> RemoveConversationMember(int ConversationGroupID, ConversationGroupMemberDtos) async{
    BehaviorSubject<BaseModel> dateVaulegeRemoveConversationMemberModel = BehaviorSubject<BaseModel>();
    await postData(url: remove_msg,query:{'ConversationGroupID':ConversationGroupID,'ConversationGroupMemberDtos':[{
      "ConversationGroupID":ConversationGroupMemberDtos,
    }]} ).then((value) {
        dateVaulegeRemoveConversationMemberModel.sink.add(BaseModel.fromJson(value.data));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaulegeRemoveConversationMemberModel;
  }
  // @override
  // Future<BehaviorSubject<AddConversationMembeResponse>> addConversationMember(int ConversationGroupID, int CreatedBy,  ConversationGroupMemberDtos) async{
  //   BehaviorSubject<AddConversationMembeResponse> dateVaulegeaddConversationMemberModel = BehaviorSubject<AddConversationMembeResponse>();
  //   await postData(url: add_conversationmember,query:{'ConversationGroupID':ConversationGroupID,'ConversationGroupMemberDtos':[{
  //   "ConversationGroupID":ConversationGroupMemberDtos,
  //   }],"CreatedBy":CreatedBy} ).then((value) {
  //       dateVaulegeaddConversationMemberModel.sink.add(AddConversationMembeResponse.fromJson(value.data));
  //    }).catchError((error){
  //     print(error.toString());
  //   });
  //   return dateVaulegeaddConversationMemberModel;
  // }
  @override
  Future<BehaviorSubject<CreateGroupChatResponse>> createGroupChat(int ConversationGroupID, String DefaultDesc,int ConversationGroupMemberDtos,int ConversationGroupMemberDtos2,
      int UsersCanLeaveGroup,
      int ReadOnly,int ProjectID,int MicroserviceID,String KeyRefID,int ConversationGroupTypeID,int CreatedBy) async{
    BehaviorSubject<CreateGroupChatResponse> dateVaulegecreateGroupChatModel = BehaviorSubject<CreateGroupChatResponse>();
    await d.postData(url: create_group_chat,query:{'ConversationGroupID':ConversationGroupID,'ConversationGroupMemberDtos':[{
    "UserProfileID":ConversationGroupMemberDtos},{"UserProfileID":ConversationGroupMemberDtos2
    }],"DefaultDesc":DefaultDesc,"UsersCanLeaveGroup":UsersCanLeaveGroup,"ReadOnly":ReadOnly,"ProjectID":ProjectID,"MicroserviceID":MicroserviceID,"KeyRefID":KeyRefID,"ConversationGroupTypeID":ConversationGroupTypeID
    ,"CreatedBy":CreatedBy} ).then((value) {
      dateVaulegecreateGroupChatModel.sink.add(CreateGroupChatResponse.fromJson(value.data));
     }).catchError((error){
      print(error.toString());
    });
    return dateVaulegecreateGroupChatModel;
  }
   @override
  Future<BehaviorSubject<BaseModel>> getHistoryMessages(int ConversationGroupID, int ProjectID, int MicroserviceID, int SenderUserProfileID, int UserProfileID) async{
    BehaviorSubject<BaseModel> dateVaulegetHistoryMessagesModel = BehaviorSubject<BaseModel>();
    // TODO: implement getHistoryMessages
    await d.postData(url: chat_gethistoryMessages,query:{'ConversationGroupID':ConversationGroupID,"ProjectID":ProjectID,"MicroserviceID":MicroserviceID,"SenderUserProfileID":SenderUserProfileID,"UserProfileID":UserProfileID} ).then((value) {
       dateVaulegetHistoryMessagesModel.sink.add(BaseModel.fromJson(value.data));
     }).catchError((error){
      print(error.toString());
    });
    return dateVaulegetHistoryMessagesModel;
  }
  @override
  Future<BehaviorSubject<Object>> ChatmemberSeenMessage(int ConversationGroupID, int UserProfileID, int MessageID) async{
    BehaviorSubject<Object> dateVauleChatmemberSeenMessageModel = BehaviorSubject<Object>();
    // TODO: implement ChatmemberSeenMessage
    await postData(url: chatmember_seensendmessage,query:{'ConversationGroupID':ConversationGroupID,"UserProfileID":UserProfileID,"MessageID":MessageID} ).then((value) {
       dateVauleChatmemberSeenMessageModel.sink.add(value.data);
    }).catchError((error){
      print(error.toString());
    });
    return dateVauleChatmemberSeenMessageModel;
  }
  @override
  Future<BehaviorSubject<Object>> addNewChatMember(int ConversationGroupID, int UserProfileID, int MessageID,int CreatedBy) async{
    BehaviorSubject<Object> dateVauleaddNewChatMemberModel = BehaviorSubject<Object>();
    // TODO: implement addNewChatMember
    await postData(url: addNewchatmember,query:{'ConversationGroupID':ConversationGroupID,"UserProfileID":UserProfileID,"MessageID":MessageID,"CreatedBy":CreatedBy} ).then((value) {
       dateVauleaddNewChatMemberModel.sink.add(value.data);
    }).catchError((error){
      print(error.toString());
    });
    return dateVauleaddNewChatMemberModel;
  }
  @override
  Future<BehaviorSubject<GetChatMembersByConversationGroupIdModelData>> getChatmembersbyconversationgroupid(int ConversationGroupID, int UserProfileID, int MessageID,int id) async {
    BehaviorSubject<GetChatMembersByConversationGroupIdModelData> dateVaulegetChatmembersModel = BehaviorSubject<GetChatMembersByConversationGroupIdModelData>();
    await d.getData(url: chatMember_getChatmembersbyconversationgroupiD(id),query:{'ConversationGroupID':ConversationGroupID,"UserProfileID":UserProfileID,"MessageID":MessageID} ).then((value) {
       dateVaulegetChatmembersModel.sink.add(GetChatMembersByConversationGroupIdModelData.fromJson(value.data));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaulegetChatmembersModel;
  }
    @override
  Future<BehaviorSubject<List<GetAllMessageModel>>> getAllMessages(int OtherOrLogedProfileID) async{
    BehaviorSubject<List<GetAllMessageModel>> dateVaule = BehaviorSubject<List<GetAllMessageModel>>();
    await d.getData(url: get_all_Message(OtherOrLogedProfileID)).then((value) {
      Iterable l = json.decode(json.encode(value.data));
      List<GetAllMessageModel> models = List<GetAllMessageModel>.from(l.map((model) => GetAllMessageModel.fromJson(model)));
      dateVaule.sink.add(models);
    }).catchError((error){
      print(error.toString());
    });
    return dateVaule;
  }
  @override
  Future<BehaviorSubject<GenerateTokenModel>> generateMessage(String ClientID, String ClientSecret, String ProjectID) async{
    // TODO: implement generateMessage
    BehaviorSubject<GenerateTokenModel> dateVaule = BehaviorSubject<GenerateTokenModel>();
    var param = {'ClientID':ClientID,'ClientSecret':ClientSecret,'ProjectID':ProjectID};
    await d.postData(url: genertateToken,query: param).then((value) {
      Map<String,dynamic> l = json.decode(value.data);
      dateVaule.sink.add(GenerateTokenModel.fromJson(l));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaule;
  }
   @override
  Future<BehaviorSubject<ShowdetailsModel>> showdetailsmessage(int LoggedInUserProfileId, int OtherUserProfileId, String Header) async{
    // TODO: implement showdetailsmessage
    BehaviorSubject<ShowdetailsModel> dateVaule = BehaviorSubject<ShowdetailsModel>();
    await d.getData(url: GetHistoryMessages(LoggedInUserProfileId,OtherUserProfileId),token: Header).then((value) {
       // Map<String, dynamic> l = json.decode(value.data);
        dateVaule.sink.add(ShowdetailsModel.fromJson(value.data));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaule;
  }
   @override
  Future<BehaviorSubject<ShowDetailsChatModel>> createGroupWithMessage(UserProfileIDConversationGroupMemberDtos1,UserProfileIDConversationGroupMemberDtos2,String MessageText,int SenderUserProfileID,int ProjectID,int MicroserviceID,String Header) async{
    BehaviorSubject<ShowDetailsChatModel> dateVaulegecreateGroupWithMessageModel = BehaviorSubject<ShowDetailsChatModel>();
    await postData(url: sentMessage,query:{'ConversationGroupMemberLst':[{
      "UserProfileID":UserProfileIDConversationGroupMemberDtos1
    },{
      "UserProfileID":UserProfileIDConversationGroupMemberDtos2
    }],"MessageText":MessageText,"SenderUserProfileID":SenderUserProfileID,"ProjectID":ProjectID,"MicroserviceID":MicroserviceID},token: Header).then((value) {
      dateVaulegecreateGroupWithMessageModel.sink.add(ShowDetailsChatModel.fromJson(value.data));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaulegecreateGroupWithMessageModel;
  }

  @override
  Future<BehaviorSubject<UserTokenModel>> login(String username, String password, String ProjectID, String Header) async{
    // TODO: implement login
    BehaviorSubject<UserTokenModel> dateVaule = BehaviorSubject<UserTokenModel>();
    Map<String,dynamic> param = {'username':username,'password':password,'ProjectID':ProjectID};
    await d.postData(url: loginUser,query: param,token: Header).then((value) {
      Map<String,dynamic> l = json.decode(value.data);
      dateVaule.sink.add(UserTokenModel.fromJson(l));
    }).catchError((error){
      print(error.toString());
    });
    return dateVaule;
  }
}