import 'package:bloc/bloc.dart';
import 'package:itg_chat/features/data/model/user_token_model.dart';
import 'package:itg_chat/features/domain/use_cases/login_usecase.dart';
import 'package:rxdart/src/subjects/behavior_subject.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'login_state.dart';

class LoginCubit extends Cubit<LoginState> {
  final LoginUseCase usecase;
  LoginCubit(this.usecase) : super(LoginInitailState());
  static LoginCubit get(context) => BlocProvider.of(context);

  Future<BehaviorSubject<UserTokenModel>> Login(String username,String password,String ProjectID,String Header)async{
    // TODO: implement getAllMessages
    emit(LoginLoadingState());
    var data = await usecase.call(username,password,ProjectID,Header);
    emit(LoginSuccessState(data));
    return data;
  }
}