
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:flutter_secure_storage/flutter_secure_storage.dart';
import 'package:get_it/get_it.dart';
import 'package:itg_chat/features/data/repository/chat_repo_implemnt.dart';
import 'package:itg_chat/features/domain/event/refersh_message_event.dart';
import 'package:itg_chat/features/domain/use_cases/create_group_withMessage.dart';
import 'package:itg_chat/features/domain/use_cases/show_details_message_usecase.dart';
import 'package:itg_chat/features/presntation/bloc/showmessagedetails/showmessagedetails_cubit.dart';
import 'package:itg_chat/features/presntation/bloc/showmessagedetails/showmessagedetails_state.dart';
import 'chat.dart';

class DetailsChatSreen extends StatelessWidget {
  var object = GetIt.instance<ShowDetailsMessagesUseCase>(),
  object2 = GetIt.instance<RefreshChatEvent>();

  var storage = FlutterSecureStorage();
  var objectDI = GetIt.instance<CahtRepoImplemtion>();
  final messageController = TextEditingController();

  @override
  Widget build(BuildContext context){
    // TODO: implement build
    return FutureBuilder(
      future: storage.read(key: "TokenUser"),
      builder: (context,AsyncSnapshot<String> value) {
        if(value.hasData)
         {
          return BlocProvider(
            create: (BuildContext context)   =>  ShowChatDetailsCubit(object,object2)..showdetailsmessage(43156,43547,  value.data  ),

            child: BlocConsumer<ShowChatDetailsCubit,ShowChatDetailsState>(
              listener: (context,state){
              },
              builder: (context,state){
                print("state ${state}");
                if (state is ShowChatDetailsSuccessState)
                  return Scaffold(
                    backgroundColor: Colors.white,
                    appBar: AppBar(
                      title: Text('Qa'),centerTitle: false
                      ,
                      backgroundColor: Colors.blue,
                      elevation: 0,
                      leading:
                      Row(children: [
                        IconButton(
                          icon: Icon(Icons.arrow_back),color: Colors.white,
                          onPressed: (){
                            Navigator.pushReplacement(
                              context,
                              MaterialPageRoute(builder: (context) => ChatSreen()),
                            );

                          },),
                      ],)
                      ,
                      actions: [IconButton(
                        icon: Icon(Icons.menu_sharp),color: Colors.white,
                        onPressed: (){

                        },)],
                    ),
                    body:
                    Column(
                      children: [
                        Expanded(
                          child: ListView.builder(
                            shrinkWrap: true,
                            itemBuilder: (context,index){
                              return GestureDetector(
                                onTap: (){
                                  Navigator.pushReplacement(
                                    context,
                                    MaterialPageRoute(builder: (context) => DetailsChatSreen()),
                                  );
                                },
                                child:Row(
                                  mainAxisAlignment: MainAxisAlignment.end,
                                  children: [
                                    ClipRRect(
                                      borderRadius: BorderRadius.circular(10.0),
                                      child: Padding(
                                        padding: const EdgeInsets.all(8.0),
                                        child: Container(
                                          color: Colors.grey[200],
                                          child:   Column(
                                            children: [
                                              Center(child: Padding(
                                                padding: const EdgeInsets.only(top:4.0),
                                                //state.entiesModel.value[index].userName
                                                child: Text(state.entiesModel.value?.data[index].messageText),
                                              )),
                                            ],
                                          )
                                          ,
                                        ),
                                      ),
                                    ),
                                    SizedBox(width: 10,),
                                    Image(image: AssetImage('image/noimage.png')),
                                  ],
                                )
                                ,
                              );
                            },itemCount: state.entiesModel.value?.data?.length,
                          ),
                        ),
                        SizedBox(height: 10,),
                        Row(
                          children: [
                            IconButton(icon: Icon(Icons.camera_alt_rounded),color: Colors.blue, onPressed: (){

                            }),
                            IconButton(icon: Icon(Icons.keyboard_voice),color: Colors.blue, onPressed: (){
                            }),
                            Container(
                                height: 100,
                                width: 230,
                                child: TextField(decoration: InputDecoration(labelText: 'Type a message...'),controller: messageController,
                                )),
                            IconButton(icon: Icon(Icons.send),color: Colors.blue, onPressed: (){
                             // createGroupWithMessage(objectDI).call(43547,43156,messageController.text,43156,1,1);
                            })
                          ],
                        ),
                      ],
                    ),
                  );
                return Scaffold();
              },
            ),
          );
        }
        else{
          return Center(child:Text(""));
        }
      },
    );

  }

}