import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:get_it/get_it.dart';
import 'package:itg_chat/features/domain/use_cases/get_All_message_usecase.dart';
import 'package:itg_chat/features/presntation/bloc/showallchat/cubit.dart';
import 'package:itg_chat/features/presntation/bloc/showallchat/state.dart';

import 'DetailsMessageScreen.dart';

class ChatSreen extends StatelessWidget {
  var object = GetIt.instance<GetHistoryMessagesUseCase>();

  @override
  Widget build(BuildContext context) {
    return BlocProvider(
      create: (BuildContext context) => ChatCubit(object)..getAllMessages(43156),
      child: BlocConsumer<ChatCubit,ChatState>(
        listener: (context,state){
        },
        builder: (context,state){
          print("state ${state}");
          if (state is ChatSuccessState)
            return Scaffold(
              backgroundColor: Colors.white,
              appBar: AppBar(
                title: Text('Chats'),centerTitle: false,
                backgroundColor: Colors.blue,
                elevation: 0,
                leading:
                Row(children: [
                  IconButton(
                    icon: Icon(Icons.arrow_back),color: Colors.white,
                    onPressed: (){
                    },),
                ],),
              ),
              body:
              Container(
                child: ListView.builder(
                    shrinkWrap: true,
                    itemBuilder: (context,index){
                      return GestureDetector(
                        onTap: (){
                          Navigator.pushReplacement(
                            context,
                            MaterialPageRoute(builder: (context) => DetailsChatSreen()),
                          );
                        },
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.start,
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: [
                            Image(image: AssetImage('image/noimage.png')),
                            Padding(
                              padding: const EdgeInsets.only(top:15.0),
                              child: Column(children: [
                                //state.entiesModel.stream.value.userName
                                Text(state.entiesModel.value[index].userName,style: TextStyle(color: Colors.blue),),
                               // Text(state.entiesModel.value[index].jobTitle,style: TextStyle(color: Colors.grey),)
                              ],),
                            ),
                            Spacer(),
                            Padding(
                              padding: const EdgeInsets.only(top:23.0,right: 7),
                            //  child: Text({state.entiesModel.value[index].seenFlag}.toString(),style: TextStyle(color: Colors.grey)),
                            )
                          ],
                        )
                        ,
                      );
                    },itemCount: state.entiesModel.value.length
                ),
              )
              ,);
          return Scaffold();
        },
      ),
    );
  }
}

