import 'dart:io';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:flutter_secure_storage/flutter_secure_storage.dart';
import 'package:get_it/get_it.dart';
import 'package:itg_chat/features/domain/use_cases/generate_token_usecase.dart';
import 'package:itg_chat/features/domain/use_cases/login_usecase.dart';
import 'package:itg_chat/features/presntation/bloc/genereatoken/generate_token_login_cubit.dart';
import 'package:itg_chat/features/presntation/bloc/login/login_cubit.dart';
import 'package:itg_chat/features/presntation/bloc/login/login_state.dart';
import '../../data/repository/chat_repo_implemnt.dart';
 import '../../domain/use_cases/chatmember_seenmessage.dart';
import '../../domain/use_cases/createGroup_Chat.dart';
import '../../domain/use_cases/getChatmembersbyconversationgroupid.dart';
import '../../domain/use_cases/get_History_Messages_BetweenTwoUsers.dart';
import '../../domain/use_cases/get_history_messages.dart';
import '../../domain/use_cases/get_list_ofseen_messages.dart';
import '../../domain/use_cases/get_list_ofunseen_messages.dart';
import '../../domain/use_cases/get_messages_usecase.dart';
import '../../domain/use_cases/remove_conversation_member.dart';
import '../../domain/use_cases/send_MessageTo_GroupBetween_TwoUsers.dart';
import '../../../DI/dependency_injection_container.dart' as di;
import 'package:get_it/get_it.dart';

import 'chat.dart';

void main() async{
  await di.init();
  HttpOverrides.global = MyHttpOverrides();
  runApp(MyApp());
}
class MyApp extends StatelessWidget {


  @override
  Widget build(BuildContext context) {
    return MultiBlocProvider(
      providers: [
        BlocProvider(
          create: (_) => GetIt.instance<generateTokenCubit>(),
        ),
      ],
      child: MaterialApp(
        title: 'Flutter Demo',
        debugShowCheckedModeBanner: false,
        theme: ThemeData(
          primarySwatch: Colors.blue,
          visualDensity: VisualDensity.adaptivePlatformDensity,
        ),
        home: MyHomePage(title: 'Flutter Demo Home Page'),
      ),
    );
  }
}
class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);
  final String title;
  @override
  _MyHomePageState createState() => _MyHomePageState();
}
class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;
  var object = GetIt.instance<GenerateMessageUseCase>();
  var objectDI = GetIt.instance<CahtRepoImplemtion>();
  final emailController = TextEditingController();
  final passwordController = TextEditingController();
  var storage = FlutterSecureStorage();
  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    GetMessegesMemberUseCase(objectDI).call(9,0,1,1,1111,1112); //
    GetHistoryMessageBetweenTwoUsers(objectDI).call(43156,43547); //
    Getlistofunseenmessages(objectDI).call(43156);
    Getlistofseenmessages(objectDI).call(43156);
    SendMessageToGroupBetweenTwoUsers(objectDI).call(9,1115,"Hello");
    RemoveConversationMember(objectDI).call(1,1113); //
    // AddConversationMemberUseCase(object).call(1,1111,1113);
    CreateGroupChat(objectDI).call(0,"hi",1115,1114,1,1,1,1,"1",1,1114);
    GetHistoryMessages(objectDI).call(0,1,1,1111,1112);
    ChatmemberSeenMessage(objectDI).call(26,1114,176); //
    GetChatmembersbyconversationgroupid(objectDI).call(1,1,1112,1) ; //

    final generateTokenCubit counterBloc = BlocProvider.of<generateTokenCubit>(context);

    storage = new FlutterSecureStorage();
    counterBloc.generateMessage("1168579-it11-7wui-3j66-obc22365", "997336911-ottob-ar2q-dy6u-fkio5624y8qg", "1").then((value) async{
      print(value.value.accessToken);
      if (value != null) {
        storage.write(key: "TokenUser", value: value.value.accessToken);
      }
    });
  }
  IOSOptions _getIOSOptions() => IOSOptions(

  );
  AndroidOptions _getAndroidOptions() => AndroidOptions(

  );


  void _incrementCounter() {
    setState(() {
      _counter++;
    });
  }
  @override
  Widget build(BuildContext context) {
    final emailController = TextEditingController();
    final passwordController = TextEditingController();
    var object = GetIt.instance<LoginUseCase>();
    var formKey = GlobalKey<FormState>();
    return BlocProvider(
      create: (BuildContext context) => LoginCubit(object),
      child: BlocConsumer<LoginCubit,LoginState>(
        listener: (context,state){},
        builder: (context,state){
          return Scaffold(
            appBar: AppBar(
              // Here we take the value from the MyHomePage object that was created by
              // the App.build method, and use it to set our appbar title.
            ),
            body: Form(
              key: formKey,
              child: SingleChildScrollView(
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.start,
                  children: <Widget>[
                    Padding(
                      padding: const EdgeInsets.only(left:20.0,top: 20),
                      child: Text(
                        'LOGIN',
                        style: TextStyle(fontSize: 24,fontWeight: FontWeight.bold),
                      ),
                    ),
                    SizedBox(height: 30,),
                    Padding(
                      padding: const EdgeInsets.all(30.0),
                      child: TextFormField(

                        controller: emailController,
                        keyboardType:TextInputType.emailAddress ,
                        validator: (value){
                          print("alii$value");
                          if (value.isEmpty == true){
                            return "enter value";
                          }
                        },
                        onFieldSubmitted: (value){
                          print(value);
                        },
                        decoration: InputDecoration(
                          labelText: 'Email',
                          labelStyle: TextStyle(
                              color:  Colors.grey
                          ),
                          border: OutlineInputBorder(),
                          enabledBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(10.0),
                              borderSide: BorderSide(color: Colors.grey)
                          ),
                          focusedBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(10.0),
                              borderSide: BorderSide(color: Colors.green)
                          ),
                        ),
                      ),
                    ),
                    SizedBox(height: 1,),
                    Padding(
                      padding: const EdgeInsets.all(30.0),
                      child: TextFormField(

                        controller: passwordController,
                        keyboardType:TextInputType.emailAddress ,
                        validator: (value){
                          print("alii$value");
                          if (value.isEmpty == true){
                            return "enter value";
                          }
                        },
                        onFieldSubmitted: (value){
                          print(value);
                        },

                        decoration: InputDecoration(
                          labelText: 'Password',
                          labelStyle: TextStyle(
                              color:  Colors.grey
                          ),
                          border: OutlineInputBorder(),
                          enabledBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(10.0),
                              borderSide: BorderSide(color: Colors.grey)
                          ),
                          focusedBorder: OutlineInputBorder(
                              borderRadius: BorderRadius.circular(10.0),
                              borderSide: BorderSide(color: Colors.green)
                          ),
                        ),
                      ),
                    ),
                    SizedBox(height: 10,),
                    Padding(
                      padding: const EdgeInsets.all(30.0),
                      child: Container(
                        height: 60,
                        width: double.infinity,
                        child: MaterialButton(onPressed: () async{
                          LoginCubit.get(context).Login(emailController.text,passwordController.text.toString(),'1', await storage.read(key: "TokenUser")).then((value){
                            print(value);
                            if (value.value.accessToken != null) {
                              Navigator.pushReplacement(
                                context,
                                MaterialPageRoute(builder: (context) => ChatSreen()),
                              );
                            }
                          });


                        },// algazzar.abdelrahman12333w@gmail.com
                          child: Text('Login'),
                          color: Color(0xFF58579C),
                        ),
                      ),
                    ),

                  ],
                ),
              ),
            ),
          );

        },
      ),
    );
  }
}
class MyHttpOverrides extends HttpOverrides{
  @override
  HttpClient createHttpClient(SecurityContext context){
    return super.createHttpClient(context)
      ..badCertificateCallback = (X509Certificate cert, String host, int port)=> true;
  }
}