import 'package:flutter/material.dart';

class ChatTextMessageWidget extends StatelessWidget {
  final String text;
  final bool isMe;

  const ChatTextMessageWidget({
    Key key,
    this.text = "",
    this.isMe = false,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        Container(
          decoration: BoxDecoration(
            color: isMe ? Color(0xffdcf2ff) : Color(0xfff9f9f9),
            borderRadius: BorderRadius.only(
              topLeft: isMe ? Radius.circular(0) : Radius.circular(20),
              topRight: isMe ? Radius.circular(20) : Radius.circular(0),
              bottomLeft: Radius.circular(20),
              bottomRight: Radius.circular(20),
            ),
          ),
          child: Padding(
            padding: const EdgeInsets.all(10.0),
            child: SelectableText(
              text,
              showCursor: true,
              toolbarOptions: ToolbarOptions(
                copy: true,
                selectAll: true,
              ),
              style: TextStyle(
                color: Color(0xff3b3b3b),
                fontSize: 18,
              ),
            ),
          ),
        ),
      ],
    );
  }
}
