import 'package:flutter/material.dart';
import 'package:photo_view/photo_view.dart';


class ImageViewer extends StatefulWidget {
  final String imageUrl;

  const ImageViewer(this.imageUrl, {Key key}) : super(key: key);

  @override
  _ImageViewerState createState() => _ImageViewerState();
}

class _ImageViewerState extends State<ImageViewer> {
  bool _showAppBar = true;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.black,
      appBar: _showAppBar
          ? AppBar(
        elevation: 2,
        backgroundColor: Colors.transparent,
        leading: IconButton(
          icon: Icon(Icons.arrow_back),
          onPressed: () => Navigator.pop(context),
        ),
        actions: [],
      )
          : PreferredSize(
        preferredSize: Size(double.infinity, kToolbarHeight),
        child: Container(),
      ),
      body: Center(
        child: GestureDetector(
          onTap: () => setState(() => _showAppBar = !_showAppBar),
          child: PhotoView(
            imageProvider: NetworkImage(widget.imageUrl),
            minScale: PhotoViewComputedScale.contained * 0.8,
            maxScale: PhotoViewComputedScale.covered * 2,
            loadingBuilder: (_, __) {
              return Center(
                child: CircularProgressIndicator(),
              );
            },
          ),
        ),
      ),
    );
  }
}
